"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonExtractor = void 0;
const path_1 = require("path");
const rxjs_1 = require("rxjs");
/**
 * Extractor that reads a JSON file at a given filepath. The path is resolved relatively to the running tasks root dir.
 */
class JsonExtractor {
    constructor(filePath) {
        this.filePath = (0, path_1.resolve)(process.cwd(), filePath);
    }
    read() {
        try {
            const content = require(this.filePath);
            if (!(content instanceof Array) && content.constructor !== Array) {
                return (0, rxjs_1.from)([content]);
            }
            return (0, rxjs_1.from)(content);
        }
        catch (e) {
            return (0, rxjs_1.throwError)(() => e);
        }
    }
}
exports.JsonExtractor = JsonExtractor;
